<template>
  <main class="SettingsView">
    <ul class="SettingsView__Fields">
      <AutoOrList
        v-model="settings.lang"
        :label="t('settings.language')"
        :options="langOptions"
        :restoreValue="savedSettings.lang"
        class="SettingsView__Languages"
        tag="li"
        :browser="langBrowser"
        noTranslate
      />

      <AutoOrList
        v-model="settings.timeZone"
        :label="t('settings.timeZone')"
        :options="timeZones"
        :restoreValue="savedSettings.timeZone"
        class="SettingsView__TimeZones"
        tag="li"
        :browser="{ value: Browser.getTimeZone() }"
        noTranslate
      >
        <span class="SettingsView__LocaleTime">{{
          localeNow
        }}</span></AutoOrList
      >

      <AutoOrList
        v-model="settings.theme"
        :label="t('settings.theme')"
        :options="themeOptions"
        :restoreValue="savedSettings.theme"
        class="SettingsView__Themes"
        tag="li"
        :browser="{
          value: Browser.getTheme(),
          label: t('settings.' + Browser.getTheme()),
        }"
        noTranslate
      />

      <RadioButton
        v-model="settings.downloadFormat"
        :label="t('settings.downloadFormat')"
        :options="downloadFormatOptions"
        :restoreValue="savedSettings.downloadFormat"
        no-translate
        tag="li"
        class="SettingsView__DownloadFormats Radio--inline"
      />

      <ToggleButton
        v-model="settings.stopOnStart"
        :label="t('settings.stopOnStart')"
        :restoreValue="savedSettings.stopOnStart"
        class="SettingsView__stopOnStart"
        tag="li"
      />

      <ToggleButton
        v-model="settings.groupBy.month"
        :label="t('settings.groupBy.month')"
        :restoreValue="savedSettings.groupBy.month"
        class="SettingsView__groupByMonth"
        tag="li"
      />
      <ToggleButton
        v-model="settings.groupBy.week"
        :label="t('settings.groupBy.week')"
        :restoreValue="savedSettings.groupBy.week"
        class="SettingsView__groupByWeek"
        tag="li"
      />
      <ToggleButton
        v-model="settings.groupBy.day"
        :label="t('settings.groupBy.day')"
        :restoreValue="savedSettings.groupBy.day"
        class="SettingsView__groupByDay"
        tag="li"
      />
    </ul>

    <div class="SettingsView__Operations">
      <Button
        :disabled="recomputing"
        @click="recompute"
        :label="t('settings.recompute')"
        class="Button--outlined Color--primary"
      />
    </div>

    <div class="SettingsView__Controls">
      <Button
        :disabled="defaultSettings"
        :icon="Icons.reset"
        :label="t('settings.reset')"
        class="SettingsView__ResetButton Button--outlined Color--danger"
        @click="reset"
      />
      <Button
        :disabled="pristine"
        :icon="Icons.restore"
        :iconLeft="true"
        :label="t('settings.restore')"
        class="SettingsView__RestoreButton Button--outlined Color--primary"
        @click="restore"
      />
    </div>
  </main>
</template>

<script lang="ts">
import { computed, defineComponent, inject, ref } from 'vue'
import { Button, RadioButton, ToggleButton } from '@/components'
import { DEFAULT_SETTINGS, settings, Browser, Now } from '@/states'
import { Icons } from '@/Icons'
import { States } from '@/types'
import { Translations } from '@/lang'
import { useTranslation } from '@/components/UseTranslation'
import AutoOrList from '@/views/settings/AutoOrList.vue'
import moment from 'moment-timezone'
import { Entries } from '@/stores'

export default defineComponent({
  name: 'view/Settings',
  components: { ToggleButton, RadioButton, Button, AutoOrList },

  setup() {
    const savedSettingsJson = JSON.stringify(settings)
    const savedSettings = JSON.parse(savedSettingsJson)

    // Copy settings for restore options
    const pristine = computed(
      () => savedSettingsJson === JSON.stringify(settings)
    )
    const defaultSettings = computed(
      () => JSON.stringify(settings) === JSON.stringify(DEFAULT_SETTINGS)
    )

    // Import translator
    const { t } = useTranslation()

    // Get all available languages
    const messages: Record<string, Translations> = inject('messages', {
      value: {},
    }).value

    const langOptions: Record<string, string> = {}
    for (const lang of Object.keys(messages)) {
      if (messages[lang]) langOptions[messages[lang]._name] = lang
    }

    const themeOptions: Record<string, States.Settings['theme']> = {
      [t('settings.themeLight') as string]: 'themeLight',
      [t('settings.themeDark') as string]: 'themeDark',
    }

    const downloadFormatOptions: Record<
      string,
      States.Settings['downloadFormat']
    > = {
      Yaml: 'yaml',
      Json: 'json',
      CSV: 'csv',
    }

    const timeZones: Record<string, string> = {}

    for (const timeZone of moment.tz.names()) {
      timeZones[timeZone] = timeZone
    }

    const recomputing = ref<boolean>(false)

    return {
      langBrowser: computed(() => {
        return {
          value: Browser.getLang(),
          label: messages[Browser.getLang()]._name,
        }
      }),
      Icons,
      timeZones,
      Browser,
      pristine,
      defaultSettings,
      savedSettings,
      restore: () => Object.assign(settings, JSON.parse(savedSettingsJson)),
      settings,
      t,
      downloadFormatOptions,
      langOptions,
      themeOptions,
      reset: () => Object.assign(settings, DEFAULT_SETTINGS),
      localeNow: computed(() => Now.value.format('LLLL')),
      recomputing,
      recompute: async () => {
        recomputing.value = true
        await Entries.normalizeAll()
        recomputing.value = false
      },
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../style/variables' as v;
@use '../style/view';

.SettingsView {
  @extend .View;

  &__Fields {
    display: flex;
    flex-direction: column;
    padding: 0;

    & > * {
      margin: v.$spacing-2 0;
      background-color: var(--background-color);
      list-style: none;
    }
  }

  &__Controls {
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: v.$spacing 0;

    & > :not(:first-child) {
      margin-left: v.$spacing;
    }
  }

  &__LocaleTime {
    flex: 1 1 100%;
  }
}
</style>
